unit AlphaLib32;

interface

uses DDDD,DDraw,d3d, d3dcaps, d3dtypes,windows,Classes,SysUtils,Graphics,
     math,Jpeg,Forms;

//fobOt@Co}XJH
const AL32_DebugMode = TRUE;

var
  //fobOt@C̍sJE^
  AL32_DebugCount : Integer = 0;

//eNX`Xg\
type T_TEXTURELIST = record
  Texture : TDDDDTexture;  //eNX`\
  FileName: String[255];   //t@C
  LinkCount : Integer;     //̃eNX`ɃNĂ鐔
  next : Pointer;          //̃|C^
end;
P_TEXTURELIST = ^T_TEXTURELIST;


//`~\
type TDRAWDATA = record
  Empty : Boolean;        //Empty
  Tex : TDDDDTexture;
  Suf : TDDDDSurface;
  mode : Integer;
  ColorKey : Boolean;
  sx,sy : array[0..3] of Single;
  dx,dy : array[0..3] of Single;
  Pri   : Integer;        //Priority
  Color : DWORD;          //ARGB
  BM    : DWORD;          //Src BlendFactor
end;

//@
BLENDMODE = (
  BM_NORMAL,      //ʏ]
  BM_ADD,         //F
  BM_MODULATE,    //Z
  BM_SUB,         //Z
  BM_FLASH,       //ʏ]ColorZ(VoodoonΉ)
  BM_NOT,         //]
  BM_SUBADD,      //ZĂZ
  BM_DIV          //GIMPłDivide (Dodge)
);

//}XN@
ALPHAMASKMODE = (
  AM_BINARY,       //l
  AM_GRAY          //WߖT
);

//AlphaLib32 ... Direct3Dɂ锼Cu
type
  TAlpha32 = class(TObject)
  private
    
  //Private錾
  protected
    QD : TDDDD;                 //QD̃|C^
    DD : array of TDRAWDATA;
    SS : array of Integer;

    aspw,asph : Single;         //AXyNg
    TexList  : P_TEXTURELIST;   //eNX`Xg
    DrawOrder: Integer;         //݂̕`o^
    MaxCount : Integer;

    FTexture  : IDirectDrawSurface7; //SetTextureœKp
    FSrcBlend : D3DBLEND;
    FDestBlend: D3DBLEND;
    FTextureOP: D3DTEXTUREOP;
    FScene    : Boolean;

    procedure   D3DInit;
    procedure   DDClear;
    procedure   RendQuickSort(St,Ed: Integer);

    function    MakeAlphaMaskFromColor(src:TBitmap; col:DWORD):TBitmap;
    function    LoadFileToBmp32(Filename:string):TBitmap;
    function    LoadBmp32BitFormat(filename:string) : TBitmap;
    function    LoadJpeg32BitFormat(filename: string): TBitmap;

    procedure   BitmapToSurface(dest:TDDDDSurface; src:TBitmap);
    procedure   BitmapToTexture(dest:TDDDDTexture; src:TBitmap);
    procedure   BitmapToTextureAlphaModulate(dest:TDDDDTexture; src:TBitmap);
    procedure   BitmapToSurfaceAlphaModulate(dest:TDDDDSurface; src:TBitmap);

    procedure   TextureListInit;
    procedure   TextureListFree;

  //public錾
  public
    //eNZCliw蕪W𒆉Ɋ񂹂j
    LINEARTEXELFIX : single; //DEF 0.25
    POINTTEXELFIX  : single; //DEF 0.00
    //X^CYCl
    PIXELFIX       : Single; //DEF -0.5
    //ARGBsNZtH[}bg̃eNX`g
    //FALSEɂƓߐFɂ^\s悤ɂȂ
    ALPHATEXTURE : Boolean;
    //jAOtB^gp邩
    LINEARFILTER : Boolean;
    //eNX`̃sNZtH[}bgD揇
    //CӂɕςĖč\܂񂱂Ƃ
    RGBPIXELFORMAT  : String;
    ARGBPIXELFORMAT : String;
    //ߐFijɂ邭蔲
    AUTOALPHAMASK : Boolean;
    //}XN̐@
    AUTOALPHAMASKMODE : ALPHAMASKMODE;

    //
    constructor Create(tQD:TDDDD; count:Integer=4096);
    //
    destructor  Destroy; override;

    //Ȑ
    procedure   DrawCurve(src:TDDDDTexture;
                          sx1,sy1,sx2,sy2 : Single;
                          dxa,dya : array of Single;
                          count : Integer;
                          Size:Single; col:DWORD; BM:BLENDMODE; pri:Integer);
    //R`eNX`]
    procedure   DrawPoly(src:TDDDDTexture;
                         sx1,sy1,sx2,sy2,sx3,sy3,sx4,sy4 : single;
                         dx1,dy1,dx2,dy2,dx3,dy3,dx4,dy4 : single;
                         col:DWORD; BM:BLENDMODE; pri:Integer);
    //P`eNX`]
    procedure   DrawTex(src : TDDDDTexture; sx1,sy1,sx2,sy2 : Single;
                        dx1,dy1 : Single; sw,sh,r : Single;
                        col : DWORD; BM : BLENDMODE; Pri : Integer);
    //P`Surface]i܂j
    procedure   DrawSuf(src : TDDDDSurface; sx1,sy1,sx2,sy2 : Single;
                        dx1,dy1,sw,sh : Single; ColorKey : Boolean; pri:Integer);
    //P`hԂ
    procedure   FillRect(sx,sy,ex,ey : single;
                         col : DWORD; BM : BLENDMODE; Pri : Integer);
    //eNX`𔺂C`
    procedure   DrawTexLine(src : TDDDDTexture;sx1,sy1,sx2,sy2 : single;
                            dx1,dy1,dx2,dy2,size : single;
                            col : DWORD; BM : BLENDMODE; Pri : Integer);
    //C`
    procedure   DrawLine(dx1,dy1,dx2,dy2,size : single;
                         col : DWORD; BM : BLENDMODE; Pri : Integer);

    //_Oiʂ𔽉fj
    procedure   Rendering;
    //ʑSNA
    procedure   Clear(col : DWORD);

    //ʁiAXyNgjݒil1:1i640x480zjj
    procedure   SetAspect(w,h : Single);

    //eNX`̓ǂݍ݂Ɖ
    function    LoadTexture(filename : String) : TDDDDTexture;
    function    FreeTexture(var t:TDDDDTexture):Boolean;

    //ݓo^Ă鐔ł˂
    property    DrawObjectCount : Integer read DrawOrder;

    //fobOo
    procedure   AL32_DebugMessage(mes : string);

    //
    function    LoadFileToTexture(filename:String) : TDDDDTexture;
    function    LoadFileToSurface(filename:String) : TDDDDSurface;

    //Direct3DœKߌQ
    procedure   D3DSetTexture(x : IDirectDrawSurface7; change:Boolean);
    procedure   D3DSetSrcBlend(x : D3DBLEND; change:Boolean);
    procedure   D3DSetDestBlend(x : D3DBLEND; change:Boolean);
    procedure   D3DSetTextureOP(x : D3DTEXTUREOP; change:Boolean);
    procedure   D3DSetScene(x : Boolean; change:Boolean);
end;

//֐
function _ARGB(aa,rr,gg,bb:DWORD) : DWORD;
function _ARGB2(aa,rr,gg,bb:DWORD) : DWORD;
function _BlendARGB(Col1,Col2,alp:DWORD) : DWORD;
function _ModulateARGB(Col1,Col2:DWORD) : DWORD;

implementation

//------------------------------------------------------------------------------
//ARGB
function _ARGB(aa,rr,gg,bb:DWORD) : DWORD;
begin
  result := (aa shl 24) or (rr shl 16) or (gg shl 8) or bb;
end;
function _ARGB2(aa,rr,gg,bb:DWORD) : DWORD;
var
  aaa,rrr,ggg,bbb : Integer;
begin
  aaa := aa;
  if (aaa > $FF)then aaa := $FF;
  rrr := rr;
  if (rrr > $FF)then rrr := $FF;
  ggg := gg;
  if (ggg > $FF)then ggg := $FF;
  bbb := bb;
  if (bbb > $FF)then bbb := $FF;

  result := (aaa shl 24) or (rrr shl 16) or (ggg shl 8) or bbb;
end;
//̐F킹
function _BlendARGB(Col1,Col2,alp:DWORD) : DWORD;
var
  aa1,rr1,gg1,bb1 : DWORD;
  aa2,rr2,gg2,bb2 : DWORD;
  alp1,alp2 : DWORD;
begin
  alp1 := alp;
  if (alp1 > 255)then alp1 := 255;
  alp2 := 255 - alp1;

  aa1 := (Col1 shr 24) and $FF;
  rr1 := (Col1 shr 16) and $FF;
  gg1 := (Col1 shr  8) and $FF;
  bb1 := (Col1       ) and $FF;

  aa2 := (Col2 shr 24) and $FF;
  rr2 := (Col2 shr 16) and $FF;
  gg2 := (Col2 shr  8) and $FF;
  bb2 := (Col2       ) and $FF;

  result := _ARGB((aa1 * alp2 + aa2 * alp1) shr 8,
                  (rr1 * alp2 + rr2 * alp1) shr 8,
                  (gg1 * alp2 + gg2 * alp1) shr 8,
                  (bb1 * alp2 + bb2 * alp1) shr 8)
end;
//̐FZ
function _ModulateARGB(Col1,Col2:DWORD) : DWORD;
var
  aa1,rr1,gg1,bb1 : DWORD;
  aa2,rr2,gg2,bb2 : DWORD;
begin
  aa1 := (Col1 shr 24) and $FF;
  rr1 := (Col1 shr 16) and $FF;
  gg1 := (Col1 shr  8) and $FF;
  bb1 := (Col1       ) and $FF;

  aa2 := (Col2 shr 24) and $FF;
  rr2 := (Col2 shr 16) and $FF;
  gg2 := (Col2 shr  8) and $FF;
  bb2 := (Col2       ) and $FF;

  result := _ARGB((aa1*aa2) shr 8,
                  (rr1*rr2) shr 8,
                  (gg1*gg2) shr 8,
                  (bb1*bb2) shr 8)
end;

//------------------------------------------------------------------------------
//Direct3D̏ݒ
procedure TAlpha32.D3DInit;
var
  viewParam:D3DVIEWPORT7;
  cr : D3DRECT;
begin
  //r[|[g̐ݒ
  with viewParam do begin
    dwX:=0; dwY:=0;
    dwWidth:=QD.BackBuffer.Width;
    dwHeight:=QD.BackBuffer.Height;
    dvMinZ:=0.0000001;
    dvMaxZ:=1.0;
  end;
  //r[|[g̓w肷
  QD.D3DDevice.SetViewport(@viewParam);

  //ʃNA
  with cr do begin
    x1:=0;
    y1:=0;
    x2:=QD.BackBuffer.Width;
    y2:=QD.BackBuffer.Height;
  end;
  asm finit; end;
  QD.D3DDevice.Clear(1,@cr,D3DCLEAR_TARGET+D3DCLEAR_ZBUFFER, 0, 1.0, 0);
end;

//------------------------------------------------------------------------------
procedure TAlpha32.DDClear;
var
  i : Integer;
begin
  for i:=0 to MaxCount-1 do
    DD[i].Empty := FALSE;
  DrawOrder := 0;
end;

//------------------------------------------------------------------------------
//ALpha32̏
constructor TAlpha32.Create(tQD : TDDDD; count:Integer=4096);
begin
  QD := tQD;
  //ő\
  MaxCount := Count;
  SetLength(DD,MaxCount);
  SetLength(SS,MaxCount);
  //Direct3D
  D3DInit;
  //eNX`Xg
  TextureListInit;
  //`NA
  DDClear;
  //ʁiAXyNgj
  //640x4801:1łB
  //WC邱ƂȂ1280x960̉ʃTCYɕ\ꍇ2:2ɂOK@
  aspw := 1.0;
  asph := 1.0;
  //eNZCliw蕪W𒆉Ɋ񂹂j
  LINEARTEXELFIX := 0.25;
  POINTTEXELFIX  := 0.00;
  //X^CYCl
  PIXELFIX := -0.5;
  //ARGBsNZtH[}bg̃eNX`g
  ALPHATEXTURE := TRUE;
  //jAOtB^gp邩
  LINEARFILTER := TRUE;
  //eNX`sNZtH[}bgD揇
  RGBPIXELFORMAT  := 'RGB888;RGB565;RGB555';//'RGB565;RGB555;RGB888';
  ARGBPIXELFORMAT := 'ARGB8888;ARGB4444';//'ARGB4444;ARGB8888';
  //rbg}bvȂꍇA邩H
  AUTOALPHAMASK := TRUE;
  AUTOALPHAMASKMODE := AM_GRAY;
  //Direct3DXe[^XœK̏
  D3DSetTexture(nil,TRUE);
  D3DSetScene(FALSE,TRUE);
  D3DSetSrcBlend(D3DBLEND_ONE,TRUE);
  D3DSetDestBlend(D3DBLEND_ONE,TRUE);
  D3DSetTextureOP(D3DTOP_MODULATE,TRUE);
end;

//------------------------------------------------------------------------------
//Ȑ\
procedure TAlpha32.DrawCurve(src: TDDDDTexture; sx1, sy1, sx2, sy2: Single;
  dxa, dya: array of Single; count: Integer; Size:Single; col: DWORD; BM: BLENDMODE;
  pri: Integer);
var
  i,j : Integer;
  ssx1,ssy1 : array[0..3] of Single;
  ddx1,ddy1 : array[0..3] of Single;
  ddx2,ddy2 : array[0..3] of Single;
  rrr,lll,www,xxx,yyy : Single;
  cx,cy : Single;
  si,co : Single;
begin
  www := Size / 2; //̑
  for i:=0 to count-2 do
  begin
    //_߂
    cx := (dxa[i] + dxa[i+1]) / 2;
    cy := (dya[i] + dya[i+1]) / 2;
    //߂
    lll := sqrt(sqr(dxa[i]-dxa[i+1])+sqr(dya[i]-dya[i+1])+1);
    lll := lll / 2;
    //px߂
    rrr := ArcTan2(dya[i+1]-dya[i],dxa[i+1]-dxa[i]);
    //WvZ
    ddx2[0] := -lll;
    ddy2[0] := -www;
    ddx2[1] :=  lll;
    ddy2[1] := -www;
    ddx2[2] := -lll;
    ddy2[2] :=  www;
    ddx2[3] :=  lll;
    ddy2[3] :=  www;
    si := sin(rrr);
    co := cos(rrr);
    for j:=0 to 3 do
    begin
      xxx := ddx2[j];
      yyy := ddy2[j];
      ddx2[j] := (co * xxx - si * yyy) + cx;
      ddy2[j] := (si * xxx + co * yyy) + cy;
    end;
    // i>0iQߖڈȍ~jȂA_⊮ADrawPolyɓn
    if (i > 0)then
    begin
      //A_⊮i_@ŕ⊮j
      xxx := (ddx1[1] + ddx2[0]) / 2;
      yyy := (ddy1[1] + ddy2[0]) / 2;
      ddx1[1] := xxx;
      ddy1[1] := yyy;
      ddx2[0] := xxx;
      ddy2[0] := yyy;
      xxx := (ddx1[3] + ddx2[2]) / 2;
      yyy := (ddy1[3] + ddy2[2]) / 2;
      ddx1[3] := xxx;
      ddy1[3] := yyy;
      ddx2[2] := xxx;
      ddy2[2] := yyy;
      //]WZo
      xxx := (sx2 - sx1) / (count-1);
      ssx1[0] := sx1 + xxx*(i-1);
      ssy1[0] := sy1;
      ssx1[1] := sx1 + xxx*i;
      ssy1[1] := sy1;
      ssx1[2] := sx1 + xxx*(i-1);
      ssy1[2] := sy2;
      ssx1[3] := sx1 + xxx*i;
      ssy1[3] := sy2;
      //o^
      DrawPoly(src,
               ssx1[0],ssy1[0], ssx1[1],ssy1[1], ssx1[2],ssy1[2], ssx1[3],ssy1[3],
               ddx1[0],ddy1[0], ddx1[1],ddy1[1], ddx1[2],ddy1[2], ddx1[3],ddy1[3],
               col,BM,pri);
    end;
    //ddx1Eddy1iO̐߁jddx2Eddy2i݂̐߁ji[
    for j:=0 to 3 do
    begin
      ddx1[j] := ddx2[j];
      ddy1[j] := ddy2[j];
    end;
  end;

  //]WZo
  i := count-1;
  xxx := (sx2 - sx1) / (count-1);
  ssx1[0] := sx1 + xxx*(i-1);
  ssy1[0] := sy1;
  ssx1[1] := sx1 + xxx*i;
  ssy1[1] := sy1;
  ssx1[2] := sx1 + xxx*(i-1);
  ssy1[2] := sy2;
  ssx1[3] := sx1 + xxx*i;
  ssy1[3] := sy2;
  //o^
  DrawPoly(src,
           ssx1[0],ssy1[0], ssx1[1],ssy1[1], ssx1[2],ssy1[2], ssx1[3],ssy1[3],
           ddx2[0],ddy2[0], ddx2[1],ddy2[1], ddx2[2],ddy2[2], ddx2[3],ddy2[3],
           col,BM,pri);

end;

//------------------------------------------------------------------------------
//R`eNX``
//dxdy,sx,sy͍̏AEAAȄŁiPolygon̎w@ƂĂ͓ꂩj
procedure TAlpha32.DrawPoly(src: TDDDDTexture; sx1, sy1, sx2, sy2, sx3,
  sy3, sx4, sy4, dx1, dy1, dx2, dy2, dx3, dy3, dx4, dy4: single;
  col: DWORD; BM: BLENDMODE; pri: Integer);
var
  i,j     : Integer;
  scx,scy : Single;
  TexelFix : Single;
begin
  inc(DrawOrder);
  i := DrawOrder-1;
  //l̑
  DD[i].Empty := TRUE;
  DD[i].tex   := src;
  DD[i].Mode  := 0;      //TDDDDTextureMode
  DD[i].Pri   := pri*MaxCount+DrawOrder;
  DD[i].Color := col;
  DD[i].BM    := DWORD(BM);
  //]W̎Zo
  scx := (sx1 + sx2 + sx3 + sx4) / 4;
  scy := (sy1 + sy2 + sy3 + sy4) / 4;
  if (LINEARFILTER = TRUE)then TexelFix := LINEARTEXELFIX
                          else TexelFix := POINTTEXELFIX;
  DD[i].sx[0] := sx1;
  DD[i].sy[0] := sy1;
  DD[i].sx[1] := sx2;
  DD[i].sy[1] := sy2;
  DD[i].sx[2] := sx3;
  DD[i].sy[2] := sy3;
  DD[i].sx[3] := sx4;
  DD[i].sy[3] := sy4;
  for j:=0 to 3 do
  begin
    if (scx > DD[i].sx[j])then DD[i].sx[j] := DD[i].sx[j] + TexelFix
                          else DD[i].sx[j] := DD[i].sx[j] - TexelFix;
    if (scy > DD[i].sy[j])then DD[i].sy[j] := DD[i].sy[j] + TexelFix
                          else DD[i].sy[j] := DD[i].sy[j] - TexelFix;
  end;
  //]W̎Zo
  DD[i].dx[0] := dx1 * aspw;
  DD[i].dy[0] := dy1 * asph;
  DD[i].dx[1] := dx2 * aspw;
  DD[i].dy[1] := dy2 * asph;
  DD[i].dx[2] := dx3 * aspw;
  DD[i].dy[2] := dy3 * asph;
  DD[i].dx[3] := dx4 * aspw;
  DD[i].dy[3] := dy4 * asph;
end;

//------------------------------------------------------------------------------
//P`eNX``
procedure TAlpha32.DrawTex(src : TDDDDTexture; sx1,sy1,sx2,sy2 : Single;
                           dx1,dy1 : Single; sw,sh,r : Single;
                           col : DWORD; BM : BLENDMODE; Pri : Integer);
var
  i : Integer;
  rrr,www,hhh : Single;
  xx1,yy1,xx2,yy2 : array[0..3] of Single;
  si,co   : Single;
begin
  //]W̎Zo
  rrr:= r * 3.14159265*2;
  si := sin(rrr);
  co := cos(rrr);
  www:= abs(sx1-sx2) / 2 * sw;
  hhh:= abs(sy1-sy2) / 2 * sh;
  xx1[0] := -www;
  yy1[0] := -hhh;
  xx1[1] := +www;
  yy1[1] := -hhh;
  xx1[2] := -www;
  yy1[2] := +hhh;
  xx1[3] := +www;
  yy1[3] := +hhh;
  for i:=0 to 3 do
  begin
    xx2[i] := (co * xx1[i] - si * yy1[i]) + dx1;
    yy2[i] := (si * xx1[i] + co * yy1[i]) + dy1;
  end;
  //DrawPolyɂ킽
  DrawPoly(src,
           sx1,sy1, sx2,sy1, sx1,sy2, sx2,sy2,
           xx2[0],yy2[0], xx2[1],yy2[1], xx2[2],yy2[2], xx2[3],yy2[3],
           Col,BM,pri);
end;

//------------------------------------------------------------------------------
//TDDDDSurface̕`
procedure TAlpha32.DrawSuf(src : TDDDDSurface; sx1,sy1,sx2,sy2 : Single;
                           dx1,dy1,sw,sh : Single; ColorKey : Boolean; pri:Integer);
var
  i,j : Integer;
  www,hhh : Single;
begin
  inc(DrawOrder);
  i := DrawOrder-1;
  //l̑
  DD[i].Empty := TRUE;
  DD[i].suf   := src;
  DD[i].Mode  := 1;      //TDDDDTextureMode
  DD[i].ColorKey := ColorKey;
  DD[i].Pri   := pri*MaxCount+DrawOrder;
  //]W
  DD[i].sx[0] := sx1;
  DD[i].sy[0] := sy1;
  DD[i].sx[1] := sx2;
  DD[i].sy[1] := sy1;
  DD[i].sx[2] := sx1;
  DD[i].sy[2] := sy2;
  DD[i].sx[3] := sx2;
  DD[i].sy[3] := sy2;
  //]W
  www := abs(sx1-sx2) / 2;
  hhh := abs(sy1-sy2) / 2;
  DD[i].dx[0] := dx1 - www;
  DD[i].dy[0] := dy1 - hhh;
  DD[i].dx[1] := dx1 + www;
  DD[i].dy[1] := dy1 - hhh;
  DD[i].dx[2] := dx1 - www;
  DD[i].dy[2] := dy1 + hhh;
  DD[i].dx[3] := dx1 + www;
  DD[i].dy[3] := dy1 + hhh;
  for j:=0 to 3 do
  begin
    DD[i].dx[j] := DD[i].dx[j] * aspw;
    DD[i].dy[j] := DD[i].dy[j] * asph;
  end;
end;

//------------------------------------------------------------------------------
//̕\
procedure TAlpha32.DrawTexLine(src : TDDDDTexture;sx1,sy1,sx2,sy2 : single;
                               dx1,dy1,dx2,dy2,size : single;
                               col : DWORD; BM : BLENDMODE; Pri : Integer);
var
  len,rot,xxx,yyy,www : single;
begin
  //_߂
  xxx := (dx1 + dx2) / 2;
  yyy := (dy1 + dy2) / 2;
  //߂
  len := sqrt(sqr(dx1-dx2)+sqr(dy1-dy2));
  len := len / abs(sx2-sx1);
  //]px߂
  rot := ArcTan2(dy2-dy1,dx2-dx1);
  rot := rot / 6.2831853;
  //߂
  www := size;
  www := www / abs(sy2-sy1);
  //
  DrawTex(src,sx1,sy1,sx2,sy2,xxx,yyy,len,www,rot,col,BM,Pri);
end;

//------------------------------------------------------------------------------
//ʂ̐\
procedure TAlpha32.DrawLine(dx1,dy1,dx2,dy2,size : single;
                            col : DWORD; BM : BLENDMODE; Pri : Integer);
begin
  DrawTexLine(nil,0,0,1,1, dx1,dy1,dx2,dy2,size,col,BM,Pri);
end;

//------------------------------------------------------------------------------
//P`
procedure TAlpha32.FillRect(sx,sy,ex,ey : single;
                            col : DWORD; BM : BLENDMODE; Pri : Integer);
var
  www,hhh,xxx,yyy : Single;
begin
  www := abs(sx-ex);
  hhh := abs(sy-ey);
  xxx := (sx+ex)/2;
  yyy := (sy+ey)/2;
  DrawTex(nil,0,0,www,hhh,xxx,yyy,1.0,1.0,0,col,BM,Pri);
end;

//------------------------------------------------------------------------------
//ۂ̉ʂɔf
procedure TAlpha32.Rendering;
var
  i : Integer;
  col,spe : DWORD;
  SrcBlend,DestBlend : D3DBLEND;
  TexOP : D3DTEXTUREOP;
  vs : array[0..3] of D3DTLVERTEX;
  w,h : single;
  srcRect,destRect : TRect;
  fx : DDBLTFX;
begin
  //ȂI
  if (DrawOrder < 1)then
  begin
    D3DSetScene(FALSE, TRUE);
    exit;
  end;
  //DDBLTFX̏
  ZeroMemory(@fx,sizeof(DDBLTFX));
  fx.dwSize := sizeof(DDBLTFX);
  //_OXe[g/eNX`Xe[g̊{IȐݒ
  with QD.D3DDevice do
  begin
    //XyLi߂Ƃj
    SetRenderState(D3DRENDERSTATE_SPECULARENABLE,DWORD(FALSE));
    //ZBufferiKvȂ̂ŎgȂj
    SetRenderState(D3DRENDERSTATE_ZWRITEENABLE,DWORD(FALSE));
    //ʔiKvȂ̂Ŗj
    SetRenderState(D3DRENDERSTATE_CULLMODE, DWORD(D3DCULL_NONE));
    //CeBOsHi2DȂ̂ŕKvȂ킯j
    SetRenderState(D3DRENDERSTATE_LIGHTING, DWORD(FALSE));
    //TexturẽtB^ݒ
    if (LINEARFILTER = TRUE)then
    begin
      SetTextureStageState(0, D3DTSS_MINFILTER,DWORD(D3DTFN_LINEAR));
      SetTextureStageState(0, D3DTSS_MAGFILTER,DWORD(D3DTFG_LINEAR));
    end
    else
    begin
      SetTextureStageState(0, D3DTSS_MINFILTER,DWORD(D3DTFN_POINT));
      SetTextureStageState(0, D3DTSS_MAGFILTER,DWORD(D3DTFG_POINT));
    end;
    SetTextureStageState(0, D3DTSS_MIPFILTER,DWORD(D3DTFP_NONE));
    //fBUO
    SetRenderState(D3DRENDERSTATE_DITHERENABLE,DWORD(False));
    //
    SetRenderState(D3DRENDERSTATE_ALPHABLENDENABLE,DWORD(True));
    //ߐF̗L
    if (ALPHATEXTURE = FALSE)then
      SetRenderState(D3DRENDERSTATE_COLORKEYENABLE,DWORD(TRUE))
    else
      SetRenderState(D3DRENDERSTATE_COLORKEYENABLE,DWORD(FALSE));
    //bv̐ݒ
    SetTextureStageState(0, D3DTSS_ADDRESS,WORD(D3DTADDRESS_WRAP));
    //eNGFƃ|SFARG1/ARG2ɐݒ肷
    SetTextureStageState(0, D3DTSS_COLORARG1,DWORD(D3DTA_TEXTURE));
    SetTextureStageState(0, D3DTSS_COLORARG2,DWORD(D3DTA_DIFFUSE));
    SetTextureStageState(0, D3DTSS_COLOROP , DWORD(D3DTOP_MODULATE));
    //eNZƃ|SAlphaɂ
    if (ALPHATEXTURE = TRUE)then
    begin
      SetTextureStageState(0, D3DTSS_ALPHAARG1, DWORD(D3DTA_TEXTURE));
      SetTextureStageState(0, D3DTSS_ALPHAARG2, DWORD(D3DTA_DIFFUSE));
      SetTextureStageState(0, D3DTSS_ALPHAOP, DWORD(D3DTOP_MODULATE));
    end
    else
    begin
      SetTextureStageState(0, D3DTSS_ALPHAARG1, DWORD(D3DTA_DIFFUSE));
      SetTextureStageState(0, D3DTSS_ALPHAARG2, DWORD(D3DTA_DIFFUSE));
      SetTextureStageState(0, D3DTSS_ALPHAOP, DWORD(D3DTOP_SELECTARG1));
    end;
  end;

  //Zl̏̏ɕёւ
  //DDpos͍Ōɓo^ꂽʒu\
  for i:=0 to DrawOrder-1 do SS[i] := i;
  if (DrawOrder > 0)then RendQuickSort(0,DrawOrder-1);
  //Xe[g
  D3DSetSrcBlend(D3DBLEND_ONE,TRUE);
  D3DSetDestBlend(D3DBLEND_ONE,TRUE);
  D3DSetTextureOP(D3DTOP_MODULATE,TRUE);
  D3DSetTexture(nil,TRUE);
  //ꉞƂȂƁARpC{im
  SrcBlend := D3DBLEND_ONE;
  DestBlend:= D3DBLEND_ONE;
  TexOP    := D3DTOP_MODULATE;
  col := $FFFFFFFF;
  spe := $00000000;

  //`悷
  for i:=0 to DrawOrder-1 do
    with DD[SS[i]] do
      if (Empty)then
      begin
        //ƂƂƏim
        Empty := FALSE;

        if (mode = 1)then
        begin
          //TDDDDSurfacȅꍇ
          //]EW̐ݒ
          srcRect.Left := Round(sx[0]);
          srcRect.Top  := Round(sy[0]);
          srcRect.Right  := Round(sx[3]);
          srcRect.Bottom := Round(sy[3]);
          destRect.Left := Round(dx[0]);
          destRect.Top  := Round(dy[0]);
          destRect.Right  := Round(dx[3]);
          destRect.Bottom := Round(dy[3]);
          //Direct3D`惂[h؂
          D3DSetScene(FALSE, FALSE);
          //`
          if (abs(abs(sx[0]-sx[3])-abs(dx[0]-dx[3])) < 2.0)then
            if (abs(abs(sy[0]-sy[3])-abs(dy[0]-dy[3])) < 2.0)then
            begin
              //{]
              if (ColorKey = TRUE)then
                Suf.Putfast(destRect.left,destRect.Top,srcRect,DDBLTFAST_SRCCOLORKEY)// or DDBLTFAST_WAIT)
              else
                Suf.Putfast(destRect.left,destRect.Top,srcRect,DDBLTFAST_NOCOLORKEY);// or DDBLTFAST_WAIT)
            end
          else
          begin
            //Lk]
            if (ColorKey = TRUE)then
              Suf.Put(destRect,srcRect,DDBLT_KEYSRC,fx)// or DDBLT_WAIT,fx)
            else
              Suf.Put(destRect,srcRect,0,fx);//DDBLT_WAIT,fx);
          end
        end
        else
        begin
          //TDDDDTexturȅꍇ
          case BLENDMODE(BM) of
            BM_NORMAL :
              begin
                SrcBlend := D3DBLEND_SRCALPHA;
                DestBlend:= D3DBLEND_INVSRCALPHA;
                TexOP    := D3DTOP_MODULATE;
                col := Color;
              end;
            BM_ADD :
              begin
                SrcBlend := D3DBLEND_ONE;   //SrcBlend := D3DBLEND_SRCALPHA;
                DestBlend:= D3DBLEND_ONE;
                TexOP    := D3DTOP_MODULATE;
                col := _BlendARGB($00000000,Color,Color shr 24);
              end;
            BM_MODULATE :
              begin
                SrcBlend := D3DBLEND_DESTCOLOR;
                DestBlend:= D3DBLEND_ZERO;
                TexOP    := D3DTOP_ADD;
                col := _BlendARGB($FFFFFFFF,Color,Color shr 24);
              end;
            BM_SUB :
              begin
                SrcBlend := D3DBLEND_ZERO;
                DestBlend:= D3DBLEND_INVSRCCOLOR;
                TexOP    := D3DTOP_MODULATE;
                col := _BlendARGB($FF000000,Color,Color shr 24);
              end;
            BM_FLASH :
              begin
                SrcBlend := D3DBLEND_SRCALPHA;
                DestBlend:= D3DBLEND_INVSRCALPHA;
                TexOP    := D3DTOP_ADD;
                col := Color;
              end;
            BM_NOT :
              begin
                col := _BlendARGB($FF000000,Color,Color shr 24);
                SrcBlend := D3DBLEND_INVDESTCOLOR;
                DestBlend:= D3DBLEND_INVSRCCOLOR;
                TexOP    := D3DTOP_MODULATE;
              end;
            BM_SUBADD :
              begin
                col := _BlendARGB($FF000000,Color,Color shr 24);
                SrcBlend := D3DBLEND_ONE;
                DestBlend:= D3DBLEND_INVSRCCOLOR;
                TexOP    := D3DTOP_MODULATE;
              end;
            BM_DIV :
              begin
                col := _BlendARGB($FF000000,Color,Color shr 24);
                SrcBlend := D3DBLEND_DESTCOLOR;
                DestBlend:= D3DBLEND_ONE;
                TexOP    := D3DTOP_MODULATE;
              end;
          end;
          //W̌vZ
          if (tex = nil)then
          begin
            w := 256;
            h := 256;
          end
          else
          begin
            w := tex.Width;
            h := tex.Height;
          end;
          //Vertexɑ
          vs[0].sx := dx[0] + PIXELFIX;    //3DX^CYɍW킹
          vs[0].sy := dy[0] + PIXELFIX;    //ڂDirect3DHelpuOp`X^[vQ
          vs[0].sz := 0.5;
          vs[0].rhw:= 0.2;
          vs[0].tu := sx[0] / w;
          vs[0].tv := sy[0] / h;
          vs[0].color   := col;
          vs[0].specular:= spe;

          vs[1].sx := dx[1] + PIXELFIX;
          vs[1].sy := dy[1] + PIXELFIX;
          vs[1].sz := 0.5;
          vs[1].rhw:= 0.2;
          vs[1].tu := sx[1] / w;
          vs[1].tv := sy[1] / h;
          vs[1].color   := col;
          vs[1].specular:= spe;

          vs[2].sx := dx[3] + PIXELFIX;
          vs[2].sy := dy[3] + PIXELFIX;
          vs[2].sz := 0.5;
          vs[2].rhw:= 0.2;
          vs[2].tu := sx[3] / w;
          vs[2].tv := sy[3] / h;
          vs[2].color   := col;
          vs[2].specular:= spe;

          vs[3].sx := dx[2] + PIXELFIX;
          vs[3].sy := dy[2] + PIXELFIX;
          vs[3].sz := 0.5;
          vs[3].rhw:= 0.2;
          vs[3].tu := sx[2] / w;
          vs[3].tv := sy[2] / h;
          vs[3].color   := col;
          vs[3].specular:= spe;

          //Direct3D`惂[hɃZbg
          D3DSetScene(TRUE, FALSE);
          //eNX`؂ւœK
          if (tex = nil)then
            D3DSetTexture(nil, FALSE)
          else
            D3DSetTexture(tex.Surface, FALSE);
          //Xe[gXV
          D3DSetSrcBlend(SrcBlend, FALSE);
          D3DSetDestBlend(DestBlend, FALSE);
          D3DSetTextureOP(TexOP, FALSE);

          asm finit; end;
          QD.D3DDevice.DrawPrimitive(D3DPT_TRIANGLEFAN,D3DFVF_TLVERTEX,@Vs[0],4,0);
          asm finit; end;
        end;

      end;

    D3DSetScene(FALSE, TRUE);

    //nim
    DrawOrder := 0;
end;

//------------------------------------------------------------------------------
//_O̍ۂ̕ёւiQuickSort@jp֐
procedure TAlpha32.RendQuickSort(St,Ed: Integer);
var
  key: integer;
  i  : integer;
  j  : integer;
  exc: integer;
begin
  if St>=Ed then Exit;

  key := St;
  i   := St + 1;
  j   := Ed;

  while True do
  begin
    while (DD[SS[i]].Pri < DD[SS[key]].Pri) and (i<ed) do inc(i);
    while (DD[SS[j]].Pri > DD[SS[key]].Pri)            do dec(j);
    if (i < j) then
    begin
      exc   := SS[i];
      SS[i] := SS[j];
      SS[j] := exc;
      inc(i);
      dec(j);
    end
    else
      Break;
  end;

  exc   := SS[j];
  SS[j]  := SS[St];
  SS[St] := exc;

  RendQuickSort(St ,j-1);
  RendQuickSort(j+1,Ed );
end;

//------------------------------------------------------------------------------
procedure TAlpha32.Clear(col : DWORD);
var
  cr : D3DRect;
begin
  //ʃNA
  with cr do begin
    x1:=0;
    y1:=0;
    x2:=QD.BackBuffer.Width;
    y2:=QD.BackBuffer.Height;
  end;
  asm finit; end;
  QD.D3DDevice.Clear(1,@cr,D3DCLEAR_TARGET, col, 1.0, 0);
end;

//------------------------------------------------------------------------------
//AXyNgݒ肷
procedure TAlpha32.SetAspect(w,h : Single);
begin
  aspw := w;
  asph := h;
  AL32_DebugMessage(format('EʁiAXyNgj %.1f x %.1f ɐݒ',[aspw,asph]));
end;





//------------------------------------------------------------------------------
//deNX`Ǘ@\
//------------------------------------------------------------------------------
//eNX`Xg
procedure TAlpha32.TextureListInit;
begin
  new(TexList);
  TexList^.FileName := '';
  TexList^.Texture := nil;
  TexList^.LinkCount := 0;
end;

//------------------------------------------------------------------------------
//BMPt@CeNX`ǂݍ
function TAlpha32.LoadTexture(filename : String) : TDDDDTexture;
var
  TempTexList : P_TEXTURELIST;
  FullPathFilename : string;
  t : TDDDDTexture;
begin
  result := nil;
  //FullPath擾
  FullPathFilename := ExpandFileName(filename);
  //ɓ摜t@Cǂݍ܂ĂȂׂj
  TempTexList := P_TEXTURELIST(TexList);
  While (TempTexList^.Texture <> nil) do
  begin
    if (TempTexList^.FileName = FullPathFilename)then
    begin
      AL32_DebugMessage('EeNX`ǂݍ݂܂(Inc LinkCount)');
      AL32_DebugMessage('  Filename : '+FullPathFilename);
      result := TempTexList^.Texture;
      inc(TempTexList^.LinkCount);
      Exit;
    end;
    TempTexList := P_TEXTURELIST(TempTexList.next);
  end;

  //܂ǂݍ܂ĂȂꍇ
  t := LoadFileToTexture(FullPathFileName);
  if (t = nil)then
  begin
    AL32_DebugMessage('t@C̓ǂݍ݂Ɏs');
    AL32_DebugMessage('  Filename : '+FullPathFilename);
    exit;
  end;

  //eNX`Xg𐶐
  new(TempTexList);
  //eNX`Xgɒǉ
  TemptexList^.Texture := t;
  TempTexList^.FileName := FullPathFilename;
  TempTexList^.LinkCount := 1;
  TempTexList^.next := TexList;
  TexList := TempTexList;
  result := t;
  AL32_DebugMessage('EeNX`ǂݍ݂܂(Create Texture)');
  AL32_DebugMessage('  Filename : '+FullPathFilename);
end;

//------------------------------------------------------------------------------
//eNX`̉
function TAlpha32.FreeTexture(var t:TDDDDTexture):Boolean;
var
  TempTexList,PrevTexList : P_TEXTURELIST;
begin
  //nilȂēnȃ{P[
  if (t = nil)then
  begin
    result := FALSE;
    exit;
  end;
  //eNX`D3DɎgĂƉłȂ̂
  QD.D3DDevice.SetTexture(0,nil);
  result := False;
  //eNX`XgɊŶ邩ׂ
  TempTexList := P_TEXTURELIST(TexList);
  PrevTexList := TempTexList;
  While (TempTexList^.Texture <> nil) do
  begin
    if (DWORD(TempTexList^.Texture) = DWORD(t))then
    begin
      //Ŷō폜
      result := True;
      dec(TempTexList^.LinkCount);
      if (TempTexList^.LinkCount > 0)then
      begin
        AL32_debugmessage('EeNX`܂(Dec LinkCount)');
        AL32_DebugMessage('  Filename : '+TempTexList^.FileName);
        result := True;
        t := nil;
        break;
      end;
      //LINKĂȂ̂ŁAォ폜
      AL32_debugmessage('EeNX`܂(Free Texture)');
      AL32_DebugMessage('  Filename : '+TempTexList^.FileName);
      if (PrevTexList = TempTexList)then    //擪ɂꍇ
      begin
        TexList :=  P_TEXTURELIST(TempTexList.next);
        tempTexList^.Texture.Free;
        t := nil;
        Dispose(TempTexList);
      end
      else                                  //ȍ~̏ꍇ
      begin
        PrevTexList.next := TempTexList.next;
        tempTexList^.Texture.Free;
        t := nil;
        Dispose(TempTexList);
      end;
      break;

    end;
    PrevTexList := TempTexList;
    TempTexList := P_TEXTURELIST(TempTexList^.next);
  end;

  if (result = False)then
    AL32_debugmessage('YeNX`Xgɂ݂͑܂');

end;

//------------------------------------------------------------------------------
//eNX`Xg̉
procedure TAlpha32.TextureListFree;
var
  TempTexList,DelTexList : P_TEXTURELIST;
begin
  AL32_Debugmessage('EeNX`Xg܂');
  TempTexList := TexList;
  while (TempTexList^.Texture <> Nil) do
  begin
    DelTexList := TempTexList;
    TempTexList := P_TEXTURELIST(TempTexList^.next);
    AL32_debugmessage(format('  YeNX`[%s]܂',[DelTexList^.FileName]));
    Dispose(DelTexList);
  end;
  Dispose(TempTexList);
end;

//------------------------------------------------------------------------------
//Textureɉ摜ǂݍށB
function TAlpha32.LoadFileToTexture(filename:String) : TDDDDTexture;
var
  bmp:TBitmap;
  Tex : TDDDDTexture;
begin
  result := nil;
  //摜ǂݍ
  bmp := LoadFileToBmp32(filename);
  //摜Ȃꍇ
  if (bmp = nil)then
  begin
    AL32_DebugMessage('摜t@CǂݍݒɃG[܂');
    AL32_DebugMessage('  Filename : '+Filename);
    exit;
  end;

  //eNX`̐
  if (ALPHATEXTURE = TRUE)then
  begin
    //掿[h
    Tex := TDDDDTexture.Create(QD, bmp.Width, bmp.Height, 0,ARGBPIXELFORMAT);
    if (Tex = nil)then
    begin
      AL32_DebugMessage('eNX`o܂');
      AL32_DebugMessage(format('  %d x %d',[bmp.Width,bmp.Height]));
      AL32_DebugMessage(format('  filename : %s',[filename]));
      AL32_DebugMessage(format('  PixelFormat : %s',[ARGBPIXELFORMAT]));
      bmp.Free;
      exit;
    end;
    BitmapToTexture(Tex,bmp);
    AL32_DebugMessage('E摜eNX`ɓWJ܂');
    AL32_DebugMessage(format('  %d x %d',[bmp.Width,bmp.Height]));
  end
  else
  begin
    //掿[h
    Tex := TDDDDTexture.Create(QD, bmp.Width, bmp.Height, 0,RGBPIXELFORMAT);
    if (Tex = nil)then
    begin
      AL32_DebugMessage('eNX`o܂');
      AL32_DebugMessage(format('  %d x %d',[bmp.Width,bmp.Height]));
      AL32_DebugMessage(format('  filename : %s',[filename]));
      AL32_DebugMessage(format('  PixelFormat : %s',[RGBPIXELFORMAT]));
      bmp.Free;
      exit;
    end;
    BitmapToTextureAlphaModulate(Tex,bmp);
    AL32_DebugMessage('E摜eNX`ɓWJ܂');
    AL32_DebugMessage(format('  %d x %d',[bmp.Width,bmp.Height]));
  end;
  //TBitmap̉
  bmp.Free;
  //eNX`Ԃ
  result := Tex;
end;

function TAlpha32.LoadFileToSurface(filename:String) : TDDDDSurface;
var
  bmp:TBitmap;
  Suf : TDDDDSurface;
begin
  result := nil;
  //摜ǂݍ
  bmp := LoadFileToBmp32(filename);
  //摜Ȃꍇ
  if (bmp = nil)then
  begin
    AL32_DebugMessage('摜t@CǂݍݒɃG[܂');
    AL32_DebugMessage('  filename : '+Filename);
    exit;
  end;
  //T[tFCX̐
  Suf := TDDDDSurface.Create(QD, bmp.Width, bmp.Height,0);
  if (Suf = nil)then
  begin
    AL32_DebugMessage('T[tFCXo܂');
    AL32_DebugMessage(format('  %d x %d',[bmp.Width,bmp.Height]));
    AL32_DebugMessage(format('  filename : %s',[filename]));
    bmp.Free;
    exit;
  end;
  BitmapToSurfaceAlphaModulate(Suf,bmp);
  AL32_DebugMessage('E摜T[tFCXɓWJ܂');
  AL32_DebugMessage(format('  %d x %d',[bmp.Width,bmp.Height]));
  //TBitmap̉
  bmp.Free;
  //eNX`Ԃ
  result := Suf;
end;

//-------------------------------------------------------------------------------
//BMP摜̓ǂݍ
function TAlpha32.LoadBmp32BitFormat(filename: string): TBitmap;
var
  ColBmp,AlpBmp,TmpBmp:TBitmap;
  NameOnly:string;
  i,j,rr,gg,bb,aa:Integer;
  ColPtr,AlpPtr,DstPtr:PDWORD;
begin
  result := nil;
  ColBmp := nil;
  NameOnly := ChangeFileExt(filename,'');
  //J[񂪂Ȃ炦`
  if (FileExists(NameOnly+'.bmp') = FALSE)then exit;
  //J[
  if (FileExists(NameOnly+'.bmp') = TRUE)then
  begin
    TmpBmp := TBitmap.Create;
    TmpBmp.LoadFromFile(NameOnly+'.bmp');
    ColBmp := TBitmap.Create;
    ColBmp.HandleType := bmDIB;
    ColBmp.PixelFormat := pf32bit;
    ColBmp.Width := TmpBmp.Width;
    ColBmp.Height := TmpBmp.Height;
    BitBlt(ColBmp.Canvas.Handle,0,0,ColBmp.Width,ColBmp.Height,
           TmpBmp.Canvas.Handle,0,0,SRCCOPY);
    TmpBmp.Free;
    AL32_DebugMessage(format('E[%s]J[Ƃēǂݍ݂܂',[NameOnly+'.bmp']));
  end;
  //
  if (FileExists(NameOnly+'_a.bmp') = TRUE)then
  begin
    TmpBmp := TBitmap.Create;
    TmpBmp.LoadFromFile(NameOnly+'_a.bmp');
    AlpBmp := TBitmap.Create;
    AlpBmp.HandleType := bmDIB;
    AlpBmp.PixelFormat := pf32bit;
    AlpBmp.Width := TmpBmp.Width;
    AlpBmp.Height := TmpBmp.Height;
    BitBlt(AlpBmp.Canvas.Handle,0,0,AlpBmp.Width,AlpBmp.Height,
           TmpBmp.Canvas.Handle,0,0,SRCCOPY);
    TmpBmp.Free;
    AL32_DebugMessage(format('E[%s]Ƃēǂݍ݂܂',[NameOnly+'_a.bmp']));
  end
  else
    AlpBmp := MakeAlphaMaskFromColor(ColBmp,$000000);
  //J[ƃꏏɂ
  TmpBmp := TBitmap.Create;
  TmpBmp.HandleType := bmDIB;
  TmpBmp.PixelFormat := pf32bit;
  TmpBmp.Width := ColBmp.Width;
  TmpBmp.Height := ColBmp.Height;
  for i:=0 to ColBmp.Height-1 do
  begin
    DstPtr := TmpBmp.ScanLine[i];
    ColPtr := ColBmp.ScanLine[i];
    AlpPtr := AlpBmp.ScanLine[i];
    for j:=0 to ColBmp.Width-1 do
    begin
      rr := (ColPtr^ shr 16) and $FF;
      gg := (ColPtr^ shr  8) and $FF;
      bb := (ColPtr^       ) and $FF;
      aa := AlpPtr^ and $FF;
      DstPtr^ := (aa shl 24) or (rr shl 16) or (gg shl 8) or bb;
      inc(DstPtr);
      inc(ColPtr);
      inc(AlpPtr);
    end;
  end;
  if (ColBmp <> nil)then ColBmp.Free;
  if (AlpBmp <> nil)then AlpBmp.Free;
  //TBitmapԂ
  result := TmpBmp;
end;

//-------------------------------------------------------------------------------
//JPEG摜̓ǂݍ
function TAlpha32.LoadJpeg32BitFormat(filename: string): TBitmap;
var
  ColBmp,AlpBmp,TmpBmp:TBitmap;
  TmpJpeg:TJpegImage;
  NameOnly:string;
  i,j,rr,gg,bb,aa:Integer;
  ColPtr,AlpPtr,DstPtr:PDWORD;
begin
  result := nil;
  ColBmp := nil;
  NameOnly := ChangeFileExt(filename,'');
  //J[񂪂Ȃ炦`
  if (FileExists(NameOnly+'.jpg') = FALSE)then exit;
  //J[
  if (FileExists(NameOnly+'.jpg') = TRUE)then
  begin
    TmpJpeg := TJpegImage.Create;
    TmpJpeg.LoadFromFile(NameOnly+'.jpg');
    TmpBmp := TBitmap.Create;
    TmpBmp.Assign(TmpJpeg);
    TmpJpeg.Free;
    ColBmp := TBitmap.Create;
    ColBmp.HandleType := bmDIB;
    ColBmp.PixelFormat := pf32bit;
    ColBmp.Width := TmpBmp.Width;
    ColBmp.Height := TmpBmp.Height;
    BitBlt(ColBmp.Canvas.Handle,0,0,ColBmp.Width,ColBmp.Height,
           TmpBmp.Canvas.Handle,0,0,SRCCOPY);
    TmpBmp.Free;
    AL32_DebugMessage(format('E[%s]J[Ƃēǂݍ݂܂',[NameOnly+'.jpg']));
  end;
  //
  if (FileExists(NameOnly+'_a.jpg') = TRUE)then
  begin
    TmpJpeg := TJpegImage.Create;
    TmpJpeg.LoadFromFile(NameOnly+'_a.jpg');
    TmpBmp := TBitmap.Create;
    TmpBmp.Assign(TmpJpeg);
    TmpJpeg.Free;
    AlpBmp := TBitmap.Create;
    AlpBmp.HandleType := bmDIB;
    AlpBmp.PixelFormat := pf32bit;
    AlpBmp.Width := TmpBmp.Width;
    AlpBmp.Height := TmpBmp.Height;
    BitBlt(AlpBmp.Canvas.Handle,0,0,AlpBmp.Width,AlpBmp.Height,
           TmpBmp.Canvas.Handle,0,0,SRCCOPY);
    TmpBmp.Free;
    AL32_DebugMessage(format('E[%s]Ƃēǂݍ݂܂',[NameOnly+'_a.jpg']));
  end
  else
    AlpBmp := MakeAlphaMaskFromColor(ColBmp,$000000);
  //J[ƃꏏɂ
  TmpBmp := TBitmap.Create;
  TmpBmp.HandleType := bmDIB;
  TmpBmp.PixelFormat := pf32bit;
  TmpBmp.Width := ColBmp.Width;
  TmpBmp.Height := ColBmp.Height;
  for i:=0 to ColBmp.Height-1 do
  begin
    DstPtr := TmpBmp.ScanLine[i];
    ColPtr := ColBmp.ScanLine[i];
    AlpPtr := AlpBmp.ScanLine[i];
    for j:=0 to ColBmp.Width-1 do
    begin
      rr := (ColPtr^ shr 16) and $FF;
      gg := (ColPtr^ shr  8) and $FF;
      bb := (ColPtr^       ) and $FF;
      aa := AlpPtr^ and $FF;
      DstPtr^ := (aa shl 24) or (rr shl 16) or (gg shl 8) or bb;
      inc(DstPtr);
      inc(ColPtr);
      inc(AlpPtr);
    end;
  end;
  if (ColBmp <> nil)then ColBmp.Free;
  if (AlpBmp <> nil)then AlpBmp.Free;
  //TBitmapԂ
  result := TmpBmp;
end;

//------------------------------------------------------------------------------
//.cbmp/.jpg.bmp̗DxʂARGB32BitBitmap`ɉ摜WJ
function TAlpha32.LoadFileToBmp32(Filename:string):TBitmap;
var
  bmp : TBitmap;
  FullPathFileName:String;
begin
  result := nil;
  bmp := nil;
  //FullPath擾
  FullPathFilename := ExpandFileName(filename);
  //t@Cgq𔲂
  FullPathFileName := ChangeFileExt(FullPathFileName,'');
  //.bmpT
  if ((FileExists(FullPathFileName+'.bmp') = TRUE)and(bmp = nil))then
  begin
    bmp := LoadBmp32BitFormat(FullPathFilename+'.bmp');
    if (bmp = nil)then
    begin
      AL32_DebugMessage(format('[%s.bmp]ǂݍݒɃG[܂',[FullPathFileName]));
      exit;
    end;
  end;
  //.jpgŒT
  if ((FileExists(FullPathFileName+'.jpg') = TRUE)and(bmp = nil))then
  begin
    bmp := LoadJpeg32BitFormat(FullPathFilename+'.jpg');
    if (bmp = nil)then
    begin
      AL32_DebugMessage(format('[%s.jpg]ǂݍݒɃG[܂',[FullPathFileName]));
      exit;
    end;
  end;
  {$IFDEF USE_CBMP}
    //.cbmpT
    if ((FileExists(FullPathFileName+'.cbmp') = TRUE)and(bmp = nil))then
    begin
      bmp := CBMP_LoadFromFile(FullPathFilename+'.cbmp',0);
      if (bmp = nil)then
      begin
        AL32_DebugMessage(format('[%s.cbmp]ǂݍݒɃG[܂',[FullPathFileName]));
        exit;
      end;
    end;
  {$ENDIF}
  result := bmp;
end;

//------------------------------------------------------------------------------
//TBitmap(ARGB32bit)̓eTDDDDSurfaceɓ]
procedure TAlpha32.BitmapToSurface(dest:TDDDDSurface; src:TBitmap);
var
  i,j,aa,rr,gg,bb,ww,hh : Integer;
  ddsd : DDSurfaceDesc2;
  ptr : PDWORD;
begin
  if (src = nil)then exit;
  if (dest = nil)then exit;
  if (src.PixelFormat <> pf32bit)then exit;
  ww := min(src.Width,dest.Width);
  hh := min(src.Height,dest.Height);
  dest.Lock(ddsd);
  for i:=0 to hh-1 do
  begin
    ptr := src.ScanLine[i];
    for j:=0 to ww-1 do
    begin
      aa := (ptr^ shr 24) and $FF;
      rr := (ptr^ shr 16) and $FF;
      gg := (ptr^ shr  8) and $FF;
      bb := (ptr^       ) and $FF;
      dest.Pixels[j,i] := dest.ARGBToPhysical(aa,rr,gg,bb);
      inc(ptr);
    end;
  end;
  dest.UnLock;
end;
//TBitmap(ARGB32bit)̓eTDDDDTextureɓ]
procedure TAlpha32.BitmapToTexture(dest:TDDDDTexture; src:TBitmap);
var
  i,j,aa,rr,gg,bb,ww,hh : Integer;
  ddsd : DDSurfaceDesc2;
  ptr : PDWORD;
begin
  if (src = nil)then exit;
  if (dest = nil)then exit;
  if (src.PixelFormat <> pf32bit)then exit;
  ww := min(src.Width,dest.Width);
  hh := min(src.Height,dest.Height);
  dest.Lock(ddsd);
  for i:=0 to hh-1 do
  begin
    ptr := src.ScanLine[i];
    for j:=0 to ww-1 do
    begin
      aa := (ptr^ shr 24) and $FF;
      rr := (ptr^ shr 16) and $FF;
      gg := (ptr^ shr  8) and $FF;
      bb := (ptr^       ) and $FF;
      dest.Pixels[j,i] := dest.ARGBToPhysical(aa,rr,gg,bb);
      inc(ptr);
    end;
  end;
  dest.UnLock;
end;
//TBitmap(ARGB32bit)̓eALphalZTDDDDTextureɓ]
procedure TAlpha32.BitmapToTextureAlphaModulate(dest:TDDDDTexture; src:TBitmap);
var
  i,j,aa,rr,gg,bb,ww,hh : Integer;
  ddsd : DDSurfaceDesc2;
  ptr : PDWORD;
begin
  if (src = nil)then exit;
  if (dest = nil)then exit;
  if (src.PixelFormat <> pf32bit)then exit;
  ww := min(src.Width,dest.Width);
  hh := min(src.Height,dest.Height);
  dest.Lock(ddsd);
  for i:=0 to hh-1 do
  begin
    ptr := src.ScanLine[i];
    for j:=0 to ww-1 do
    begin
      aa := (ptr^ shr 24) and $FF;
      rr := (ptr^ shr 16) and $FF;
      gg := (ptr^ shr  8) and $FF;
      bb := (ptr^       ) and $FF;
      rr := (rr * aa) shr 8;
      gg := (gg * aa) shr 8;
      bb := (bb * aa) shr 8;
      dest.Pixels[j,i] := dest.ARGBToPhysical(aa,rr,gg,bb);
      inc(ptr);
    end;
  end;
  dest.UnLock;
end;
//TBitmap(ARGB32bit)̓eALphalZTDDDDSurfaceɓ]
procedure TAlpha32.BitmapToSurfaceAlphaModulate(dest:TDDDDSurface; src:TBitmap);
var
  i,j,aa,rr,gg,bb,ww,hh : Integer;
  ddsd : DDSurfaceDesc2;
  ptr : PDWORD;
begin
  if (src = nil)then exit;
  if (dest = nil)then exit;
  if (src.PixelFormat <> pf32bit)then exit;
  ww := min(src.Width,dest.Width);
  hh := min(src.Height,dest.Height);
  dest.Lock(ddsd);
  for i:=0 to hh-1 do
  begin
    ptr := src.ScanLine[i];
    for j:=0 to ww-1 do
    begin
      aa := (ptr^ shr 24) and $FF;
      rr := (ptr^ shr 16) and $FF;
      gg := (ptr^ shr  8) and $FF;
      bb := (ptr^       ) and $FF;
      rr := (rr * aa) shr 8;
      gg := (gg * aa) shr 8;
      bb := (bb * aa) shr 8;
      dest.Pixels[j,i] := dest.ARGBToPhysical(aa,rr,gg,bb);
      inc(ptr);
    end;
  end;
  dest.UnLock;
end;

//------------------------------------------------------------------------------
//fobOo
procedure TAlpha32.AL32_DebugMessage(mes : string);
var
  ff : TextFile;
  fileName : string;
begin
  //fobO`ǁH
  if (AL32_DebugMode = False)then Exit;
  //fobOt@C̎w
  FileName := ExtractFilePath(Application.Exename) + 'AL32DEBUG.TXT';
  //t@CJ
  AssignFile(ff,FileName);

  //AvO̎sA͂߂Ă݂̏ȂAt@CNA
  if AL32_DebugCount = 0 then ReWrite(ff)
                         else Append(ff);
  Inc(AL32_DebugCount);
  //s
  Writeln(ff,Format('#%03d...%s',[AL32_DebugCount,mes]));
  //t@C
  CloseFile(ff);
end;

//------------------------------------------------------------------------------
//Direct3DXe[^XœKߌQ
procedure TAlpha32.D3DSetDestBlend(x: D3DBLEND; change:Boolean);
begin
  if ((FDestBlend <> x)or(change = TRUE)) then
  begin
    asm finit; end;
    QD.D3DDevice.SetRenderState(D3DRENDERSTATE_DESTBLEND,DWORD(x));
    asm finit; end;
    FDestBlend := x;
  end;
end;

procedure TAlpha32.D3DSetSrcBlend(x: D3DBLEND; change:Boolean);
begin
  if((FSrcBlend <> x)or(change = TRUE))then
  begin
    asm finit; end;
    QD.D3DDevice.SetRenderState(D3DRENDERSTATE_SRCBLEND ,DWORD(x));
    asm finit; end;
    FSrcBlend := x;
  end;
end;

procedure TAlpha32.D3DSetTexture(x: IDirectDrawSurface7; change:Boolean);
begin
  if ((FTexture <> x)or(change = TRUE))then
  begin
    asm finit; end;
    QD.D3DDevice.SetTexture(0,x);
    asm finit; end;
    FTexture := x;
  end;
end;

procedure TAlpha32.D3DSetTextureOP(x: D3DTEXTUREOP; change:Boolean);
begin
  if ((FTextureOP <> x)or(change = TRUE))then
  begin
    asm finit; end;
    QD.D3DDevice.SetTextureStageState(0,D3DTSS_COLOROP,DWORD(x));
    asm finit; end;
    FTextureOP := x;
  end;
end;

procedure TAlpha32.D3DSetScene(x: Boolean; change:Boolean);
begin
  if ((FScene <> x)or(change =TRUE))then
  begin
    if (x = TRUE)then
    begin
      asm finit; end;
      QD.D3DDevice.BeginScene;
      asm finit; end;
    end
    else
    begin
      asm finit; end;
      QD.D3DDevice.EndScene;
      asm finit; end;
      //uf`ɂẮAEndSceneĂԂƃXe[^XĂꍇ肻Ȃ̂
      //ɔďĂ
      D3DSetTexture(nil,FALSE);
      D3DSetDestBlend(D3DBLEND(0),FALSE);
      D3DSetSrcBlend(D3DBLEND(0),FALSE);
      D3DSetTextureOP(D3DTEXTUREOP(0),FALSE);
    end;
    FScene := x;
  end;
end;

//------------------------------------------------------------------------------
//}XN̐
function TAlpha32.MakeAlphaMaskFromColor(src: TBitmap;
  col: DWORD): TBitmap;
var
  dest : TBitmap;
  procedure MakeMaskBinary(s,d:TBitmap; ck:DWORD);
  var
    i,j : Integer;
    sp,dp : PDWORD;
  begin
    for i:=0 to s.Height-1 do
    begin
      sp := s.ScanLine[i];
      dp := d.ScanLine[i];
      for j:=0 to s.Width-1 do
      begin
        if (sp^ <> ck)then dp^ := $FF
                      else dp^ := $00;
        inc(sp);
        inc(dp);
      end;
    end;
  end;
  procedure MakeMaskGray(s,d:TBitmap; ck:DWORD);
  var
    i,j,ii,jj : Integer;
    aa    : DWORD;
    sp,ssp,dp : PDWORD;
    xx,yy : Integer;
  begin
    for i:=0 to s.Height-1 do
    begin
      dp := d.ScanLine[i];
      sp := s.ScanLine[i];
      for j:=0 to s.Width-1 do
      begin
        aa := 0;
        if (sp^ <> ck)then
          for ii:=0 to 2 do
            for jj:=0 to 2 do
            begin
              xx := j+jj-1;
              yy := i+ii-1;
              if ((xx < 0)or(xx > s.Width-1))then continue;
              if ((yy < 0)or(yy > s.Height-1))then continue;
              ssp := s.ScanLine[yy];
              inc(ssp,xx);
              if (ssp^ <> ck)then inc(aa,255);
            end;
        dp^ := aa div 9;
        inc(dp);
        inc(sp);
      end;
    end;
  end;
begin
  result := nil;
  if (src = nil)then exit;
  //AlphaBmp𐶐
  dest := TBitmap.Create;
  dest.PixelFormat := pf32Bit;
  dest.HandleType := bmDIB;
  dest.Width  := src.Width;
  dest.Height := src.Height;
  if(AUTOALPHAMASK = TRUE)then
  begin
    //}XN[hɂĐ
    case AUTOALPHAMASKMODE of
      AM_BINARY : MakeMaskBinary(src,dest,col);
      AM_GRAY   : MakeMaskGray(src,dest,col);
    end;
  end
  else
  begin
    //isjœhԂ
    dest.Canvas.Brush.Color:= $02FFFFFF;
    dest.Canvas.FillRect(rect(0,0,dest.Width,dest.Height));
  end;

  result := dest;
end;

//------------------------------------------------------------------------------
//
destructor TAlpha32.Destroy;
begin
  DDClear;
  TextureListFree;

  inherited;
end;

end.
